#!/usr/bin/perl
use strict;
use warnings;
use POSIX qw(strftime);
use DBI::DBD;
use Mail::Sendmail;

our($dbfile,$from,$rcpt,$subject);
require config;

my $now = time;
my $timeframe = 24 * 3600;	# 24h
my $msg;

# connect to the database
my $db = DBI->connect("dbi:SQLite2:dbname=$dbfile") or die "db connect failed";

# streams within the timeframe
my $sql = $db->prepare("SELECT streamid, start, due, comment FROM stream WHERE (start > $now AND start < $now+$timeframe)");
$sql->execute();
while(my($streamid,$start,$due,$comment) = $sql->fetchrow_array()) {
	$start = localtime($start);
	$due = localtime($due);
	$msg .= sprintf("Stream %d (%s)\nBegin: %s\nEnd: %s\n\n", $streamid, $comment, $start, $due);
}
$sql->finish();

if (defined($msg)) {
	my %mail = (
		From       => $from,
		To         => $rcpt,
		Subject    => $subject,
		Smtp       => '127.0.0.1',
		Message    => $msg
	);
	sendmail(%mail) or die $Mail::Sendmail::error;
}
