<?php

require_once 'inc/common.inc.php';
require_once 'inc/functions.inc.php';

$now = date(U);

if ( isset($_POST['do']) && preg_match("/^(Edit|Stop|Delete)$/", $_POST['do']) ) {
	$result = $db->query("
		SELECT streamid, start, due, running
		FROM stream
		WHERE streamid='" . sqlite_escape_string($_GET[id]) . "'
		;","Get stream information to change");

	$stream = sqlite_fetch_array($result, SQLITE_ASSOC);
}

switch ($_POST['do']) {
case 'Delete':
	if ( $stream[running] == 'false' && $now < $stream[due] ) {
		$result = $db->query("
			DELETE FROM stream
			WHERE streamid='" . sqlite_escape_string($_GET[id]) . "'
			AND running='false'
			;","Delete stream &#39;{$_GET[id]}&#39;.");

		$form_success = "Stream &#39;{$_GET[id]}&#39; successfully deleted.";
	} else
		$form_error = "Error: Can not delete, stream is running or finished.";
break;
case 'Stop':
	if ( $stream[running] == 'true' ) {
		$result = $db->query("
			UPDATE stream
			SET due={$now}
			WHERE streamid='" . sqlite_escape_string($_GET[id]) . "'
			;","Stop stream &#39;{$_GET[id]}&#39;.");

		$form_success = "Backend will be instructed to stop stream &#39;{$_GET[id]}&#39;.";
	} else
		$form_error = "Error: Can not stop, stream is not running.";
break;
case 'Edit':
	$form_submit = true;

	if ( $now < $stream[start] )
		$stream[start] = $_POST['start'];
	else
		$stream[start] = date("Y-m-d H:i", $stream[start]);
		
	$new_stream = make_stamp(trim($stream['start']), trim($_POST['due']), true);

	if ($new_stream) {
		$result = $db->query("
			SELECT streamid as id, start, due FROM stream
			;","Check overlap streams");

		# calc if there is overlap
		$overlap = false;
		while ($row = sqlite_fetch_array($result, SQLITE_ASSOC)) {
			if ( !($new_stream[start] < $row[start] && $new_stream[due] < $row[start]
					|| $new_stream[start] > $row[due] && $new_stream[due] > $row[due])
					&& $row[id] != $_GET[id]) {
				$overlap = true;
				$form_submit = false;
				$form_error = "Error: Stream overlaps stream {$row[id]}.";
			}
		}
	} else {
		$form_submit = false;
		$form_error = "Error: Invalid input to edit stream &#39;{$_GET[id]}&#39;.";
	}

	if ($form_submit && $stream[due] < $now ) {
		$form_submit = false;
		$form_error = "Error: Cannot edit a finished stream.";
	}

	if ($form_submit && $new_stream[due] < $now) {
		$form_submit = false;
		$form_error = "Error: End must be in the future of stream &#39;{$_GET[id]}&#39;.";
	}

	if ($form_submit) {
		$result = $db->query("
			UPDATE stream
			SET
				start={$new_stream[start]},
				due={$new_stream[due]},
				comment='" . sqlite_escape_string($_POST['comment']) . "'
			WHERE streamid='" . sqlite_escape_string($_GET[id]) . "'
			;","Edit stream &#39;{$_GET[id]}&#39;.");
		
		$form_success = "Stream &#39;{$_GET[id]}&#39; successfully updated.";
	}
break;
}

echo <<<EOT
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
<head>
	<title>Stream Planner - Edit</title>
	<link rel="stylesheet" type="text/css" href="layout/style.css" />
	<link rel="Shortcut Icon" type="image/png" href="layout/favicon.png" />
	<script type="text/javascript" src="submit.js"></script>
</head>
<body>

<h1><a href="">Stream Planner</a></h1>

<p><img src="layout/back.png" alt="" /> <a href="index.php">Back</a></p>

<h2><img src="layout/edit-22.png" alt="" /> Edit</h2>

EOT;

if (isset($form_error))
	echo "<p style=\"color: red;\">{$form_error}</p>";
	
if (isset($form_success))
	echo "<p style=\"color: darkgreen;\">{$form_success}</p>";

$result = $db->query("
	SELECT streamid, start, running, due, finished, comment
	FROM stream
	WHERE streamid='" . sqlite_escape_string($_GET[id]) . "'
	;","Get stream to edit");

if (sqlite_num_rows($result) != 1) {
	echo "<p style=\"color: red;\">No stream found matching id &#39;{$_GET[id]}&#39;</p>";
} else {

	$stream = sqlite_fetch_array($result);
	
	if ($stream[running] != 'false')
		$stream[show][running] = '<img src="layout/play.png" alt="yes" />';
	else
		if ( $now > $stream[start] && $now < $stream[due] )
			$stream[show][running] = '<img src="layout/warning.png" alt="no" />';
		else
			$stream[show][running] = 'no';
	
	if ($stream[finished] != 'false')
		$stream[show][finished] = '<img src="layout/ok.png" alt="yes" />';
	else
		$stream[show][finished] = 'no';
	
	$stream[show][start] = date("Y-m-d H:i", $stream[start]);
	$stream[show][due] = date("Y-m-d H:i", $stream[due]);
	$stream[show][comment] = entities($stream[comment]);
	
	echo <<<EOT
<form action="" method="post">
<table>
<tr>
	<th>streamid:</th>
	<td>
		<input id="do" name="do" type="hidden" value="" />
		{$_GET['id']}
	</td>
</tr>
<tr>
	<th>running:</th>
	<td>{$stream[show][running]}</td>
</tr>
<tr>
	<th>finished:</th>
	<td>{$stream[show][finished]}</td>
</tr>
<tr>
	<th>start:</th>
	<td>

EOT;

	if ( $now > $stream[start] && $now < $stream[due] || $stream[running] != 'false' || $now > $stream[due] )
		echo "\t\t" . $stream[show][start] . "\n";
	else
		echo "\t\t<input class=\"text\" name=\"start\" type=\"text\" value=\"{$stream[show][start]}\" />\n";
	
	echo <<<EOT
	</td>
</tr>
<tr>
	<th>end:</th>
	<td>

EOT;

	if ( $now > $stream[due] )
		echo $stream[show][due];
	else
		echo "\t\t<input class=\"text\" name=\"due\" type=\"text\" value=\"{$stream[show][due]}\" />\n";
	
	echo <<<EOT
	</td>
</tr>
<tr>
	<th>comment:</th>
	<td>

EOT;

	if ( $now > $stream[due] )
		echo $stream[show][due];
	else
		echo "\t\t<input class=\"text\" name=\"comment\" type=\"text\" value=\"{$stream[show][comment]}\" />\n";
	
	echo <<<EOT
	</td>
</tr>

EOT;

	if ( $now <= $stream[due] ) {
		$action = $stream[running] != 'false' ? 'Stop' : 'Delete';

		echo <<<EOT
<tr>
	<th></th>
	<td>
		<input class="button" type="submit" value="Change" onclick="submitForm('Edit')" />
		<input class="redbutton" type="submit" value="{$action}" onclick="submitForm('{$action}')" />
	</td>
</tr>

EOT;
	}

	echo <<<EOT
</table>
</form>

EOT;
}

show_footer();

echo <<<EOT
</body>
</html>

EOT;
?>
