<?php

require_once 'common.inc.php';

// htmlentities
function entities($value){
	return htmlentities(stripslashes($value), ENT_QUOTES, "UTF-8");
}

# show table header
function show_stream_th() {
	echo <<<EOT
<tr>
	<th class="streamid">id</th>
	<th class="running">running</th>
	<th class="finished">finished</th>
	<th class="start">start</th>
	<th class="due">due</th>
</tr>

EOT;
}

function show_footer() {
	global $config;
	global $db;

	$result = $db->query("
		SELECT version
		FROM general
		;","Get stream-planner version");
	$version = sqlite_fetch_single($result);

	echo <<<EOT
<p class="small">by <a href="http://pommi.nethuis.nl/">Pim van den Berg</a> - Stream Planner {$version} is distributed under the GNU General Public License (GPL)</p>

EOT;
}

# show streams
function show_stream($id, $type="history") {
	global $db;

	$result = $db->query("
		SELECT streamid as id, running, finished, start, due, comment
		FROM stream
		WHERE id=$id
		;","Get data from stream $id");
	
	$stream = sqlite_fetch_array($result, SQLITE_ASSOC);

	if ( date(U) < $stream[due] ) {
		$stream[edit] = "\t<td class=\"edit\"><a href=\"edit.php?id={$stream[id]}\"><img src=\"layout/edit.png\" alt=\"edit\" /></a></td>\n";
	}

	$stream[start] = date("Y-m-d H:i", $stream[start]);
	$stream[due] = date("Y-m-d H:i", $stream[due]);
	$stream[comment] = entities($stream[comment]);

	if ($stream[running] != 'false')
		$stream[running] = '<img src="layout/play.png" alt="yes" />';
	else
		if ($type == "running")
			$stream[running] = '<img src="layout/warning.png" alt="no" />';
		else
			$stream[running] = 'no';
	
	if ($stream[finished] != 'false')
		$stream[finished] = '<img src="layout/ok.png" alt="yes" />';
	else
		$stream[finished] = 'no';

	echo <<<EOT
<tr>
	<td class="streamid">{$stream[id]}</td>
	<td class="running">{$stream[running]}</td>
	<td class="finished">{$stream[finished]}</td>
	<td class="start">{$stream[start]}</td>
	<td class="due">{$stream[due]}</td>

EOT;

	if (!empty($stream[comment])) {
		echo <<<EOT
	<td><img src="layout/info.png" alt="{$stream[comment]}" title="{$stream[comment]}" /></td>

EOT;
	}

	echo $stream[edit];

	echo <<<EOT
</tr>

EOT;
}

function make_stamp($start, $due, $edit=false) {
	if ( preg_match("/^\d{4}-\d{1,2}-\d{1,2} \d{1,2}:\d{2}$/", $start) ) {
		$value = preg_split("/[ :-]/", $start);
		$stream[start] = mktime($value[3], $value[4], 0, $value[1], $value[2], $value[0]);

		if ($stream[start] < date(U) && !$edit)
			return 0;

	} elseif ( preg_match("/^now$/", $start) ) {
		switch ($start) {
			case 'now':
				$stream[start] = date(U);
			break;
		}

	} else {
		return 0;
	}

	if ( preg_match("/^\d{4}-\d{1,2}-\d{1,2} \d{1,2}:\d{2}$/", $due) ) {
		$value = preg_split("/[ :-]/", $due);
		$stream[due] = mktime($value[3], $value[4], 0, $value[1], $value[2], $value[0]);

	} elseif ( preg_match("/^\+[0-9]+([,\.][0-9]+)?[hms]$/", $due) ) {
		$src = substr($due, -1);
		$value = substr($due, 1, -1);
		switch ($src) {
			case 'h':	$src = 3600;	break;
			case 'm':	$src = 60;		break;
			default:	$src = 1;		break;
		}
		$stream[due] = $stream[start] + ($value * $src);

	} else {
		return 0;
	}

	if ($stream[start] < $stream[due])
		return $stream;
	else
		return 0;
}

?>
